## spades 3.13.1+dfsg

=== assembler/src/CMakeLists.txt ===
# -*- cmake -*-
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

# Hard prerequisites
cmake_minimum_required(VERSION 2.8.12)

# allow more human readable "if then else" constructs
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE) 

# modules to find additional libraries (like zlib, boost and etc)
# Add path for custom modules
set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
# Define various dirs
set(SPADES_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SPADES_MODULES_DIR ${SPADES_MAIN_SRC_DIR}/common)
set(SPADES_MAIN_INCLUDE_DIR ${SPADES_MAIN_SRC_DIR}/include)
set(SPADES_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(SPADES_TOOLS_BINARY_DIR ${SPADES_BINARY_DIR}/bin)
set(SPADES_BUILT_INCLUDE_DIR ${SPADES_BINARY_DIR}/include)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SPADES_TOOLS_BINARY_DIR})
set(EXT_DIR "${CMAKE_SOURCE_DIR}/../ext")
set(SPADES_CFG_DIR "${CMAKE_SOURCE_DIR}/../configs")

# Uncomment for gprof profiling
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
#SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
#SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")

# Everything option-dependent
include(options)

# Sanity check our source directory to make sure that we are not trying to
# generate an in-tree build 
if ((CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR) OR
    (CMAKE_SOURCE_DIR STREQUAL "${CMAKE_BINARY_DIR}/src"))
  message(FATAL_ERROR "In-source builds are not allowed.
Please create a directory and run cmake from there, passing the path
to this source directory as the last argument.
This process created the file `CMakeCache.txt' and the directory `CMakeFiles'.
Please delete them.")
endif()

# Handle commond deps
include(deps)

# Add flags if necessary
include(flags)

# Handle common includes
include(includes)

# Handle common libs
include(libs)

include(GetGitRevisionDescription)
get_git_head_revision(SPADES_GIT_REFSPEC SPADES_GIT_SHA1)
if ((NOT SPADES_GIT_REFSPEC) OR (SPADES_GIT_REFSPEC STREQUAL "GITDIR-NOTFOUND"))
  set(SPADES_GIT_REFSPEC "N/A")
endif()
if (NOT SPADES_GIT_SHA1)
  set(SPADES_GIT_SHA1 "N/A")
endif()

message("Building SPAdes from ${SPADES_GIT_REFSPEC}, sha: ${SPADES_GIT_SHA1}")

configure_file("${SPADES_MAIN_INCLUDE_DIR}/config.hpp.in"
               "${SPADES_BUILT_INCLUDE_DIR}/config.hpp")
configure_file("${SPADES_MAIN_INCLUDE_DIR}/version.hpp.in"
               "${SPADES_BUILT_INCLUDE_DIR}/version.hpp")

# Build external dependencies (if any)
add_subdirectory("${EXT_DIR}/src" "${Project_BINARY_DIR}/ext")
add_subdirectory("${EXT_DIR}/tools" "${Project_BINARY_DIR}/ext_tools")

# Setup warnings
add_compile_options(-Wall -Wextra -Wconversion -Wno-sign-conversion -Wno-long-long -Wwrite-strings)
if (NOT OPENMP_FOUND)
  add_compile_options(-Wno-unknown-pragmas)
endif()

# Looking for README.md
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../README.md")
  #installing from archive
  set(README_MD_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../README.md")
else()
  #installing from the repo
  set(README_MD_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../README.md")
endif()

# sub projects
add_subdirectory(common)
add_subdirectory(projects)
add_subdirectory(spades_pipeline)


# Main pipeline script
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../spades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../metaspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../plasmidspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../rnaspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../truspades.py"
        DESTINATION bin
        COMPONENT runtime)

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../spades_init.py"
        DESTINATION bin
        COMPONENT runtime)
# FIXME: Should we just configure spades_init instead?
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../VERSION"
        DESTINATION share/spades
        COMPONENT runtime)
# Test datasets
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../test_dataset"
        DESTINATION share/spades)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../test_dataset_truspades"
        DESTINATION share/spades)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../test_dataset_plasmid"
        DESTINATION share/spades)
# manual, LICENSE, and GPLv2
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${README_MD_PATH}"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../truspades_manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../rnaspades_manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../GPLv2.txt"
        DESTINATION share/spades
        COMPONENT runtime)

# Random stuff
include(CMakeListsInternal.txt)

# Packaging
include(pack)

# Workaround for poor CLion users
file(GLOB_RECURSE clion_all_headers
  ${CMAKE_SOURCE_DIR}/*.hpp ${CMAKE_SOURCE_DIR}/*.h)
add_custom_target(all_clion SOURCES ${clion_all_headers})

=== assembler/ext/src/CMakeLists.txt ===
# -*- cmake -*-

add_subdirectory(jemalloc)
add_subdirectory(nlopt)
add_subdirectory(python_libs/joblib2)
add_subdirectory(python_libs/joblib3)
add_subdirectory(python_libs/pyyaml2)
add_subdirectory(python_libs/pyyaml3)
add_subdirectory(ConsensusCore)
add_subdirectory(bamtools)
add_subdirectory(samtools)
add_subdirectory(cppformat)
add_subdirectory(ssw)
add_subdirectory(cityhash)
add_subdirectory(getopt_pp)
add_subdirectory(llvm)
add_subdirectory(htrie)
add_subdirectory(bwa)
add_subdirectory(gqf)
add_subdirectory(edlib)
add_subdirectory(gfa1)

=== assembler/src/common/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(common_modules CXX)

add_subdirectory(pipeline)
add_subdirectory(sequence)
add_subdirectory(assembly_graph)
add_subdirectory(modules/path_extend)
add_subdirectory(modules)
add_subdirectory(paired_info)
add_subdirectory(stages)
add_subdirectory(utils)
add_subdirectory(io)
add_subdirectory(utils/kmer_mph)
add_subdirectory(modules/coverage_model)

add_library(common_modules STATIC empty.cpp)

target_link_libraries(common_modules assembly_graph input pipeline sequence coverage_model paired_info path_extend stages utils mph_index modules)

=== assembler/src/projects/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

add_subdirectory(spades)
add_subdirectory(hammer)
add_subdirectory(ionhammer)
add_subdirectory(corrector)
add_subdirectory(scaffold_correction)
add_subdirectory(kmercount)
add_subdirectory(gbuilder)
add_subdirectory(gmapper)

=== assembler/src/spades_pipeline/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(spades_pipeline)

# SPAdes pipeline scripts
install(FILES hammer_logic.py process_cfg.py spades_logic.py corrector_logic.py support.py options_storage.py lucigen_nxmate.py
        DESTINATION share/spades/spades_pipeline
        COMPONENT runtime)
# TruSpades module
install(FILES truspades/reference_construction.py truspades/moleculo_filter_contigs.py truspades/break_by_coverage.py truspades/moleculo_postprocessing.py truspades/barcode_extraction.py truspades/generate_quality.py truspades/id_generation.py truspades/launch_options.py truspades/string_dist_utils.py
        DESTINATION share/spades/spades_pipeline/truspades
        COMPONENT runtime)
# Common module
install(FILES common/alignment.py common/parallel_launcher.py common/sam_parser.py common/SeqIO.py common/__init__.py
        DESTINATION share/spades/spades_pipeline/common
        COMPONENT runtime)

=== assembler/ext/src/ConsensusCore/CMakeLists.txt ===
project(ConsensusCore CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include/ConsensusCore)

add_library(ConsensusCore STATIC 
            AffineAlignment.cpp
            Coverage.cpp
            Mutation.cpp
            PairwiseAlignment.cpp
            Sequence.cpp
            Utils.cpp
            Version.cpp
            Matrix/DenseMatrix.cpp
            Matrix/SparseMatrix.cpp
            Poa/PoaConfig.cpp
            Poa/PoaConsensus.cpp
            Poa/PoaGraph.cpp)

=== assembler/ext/src/cityhash/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(cityhash CXX)

add_library(cityhash STATIC
            city.cc)

=== assembler/ext/src/gfa1/CMakeLists.txt ===
############################################################################
# Copyright (c) 2018 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(gfa1 C)


# Create libraries.
add_library(gfa1 STATIC gfa.c)
target_link_libraries(gfa1 ${ZLIB_LIBRARIES})

=== assembler/ext/src/jemalloc/CMakeLists.txt ===
# -*- cmake -*-

############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(jemalloc C CXX)

include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckFunctionExists)
include(CheckCSourceCompiles)
include(CheckTypeSize)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include)
include_directories(${SPADES_BUILT_INCLUDE_DIR})

check_include_files(features.h HAVE_FEATURES_H)
check_include_files(sys/cdefs.h HAVE_SYS_CDEFS_H)

set(JEMALLOC_VERSION "3.2.0-0-g87499f6748ebe4817571e817e9f680ccb5bf54a9")
set(JEMALLOC_VERSION_MAJOR "3")
set(JEMALLOC_VERSION_MINOR "2")
set(JEMALLOC_VERSION_BUGFIX "0")
set(JEMALLOC_VERSION_NREV "0")
set(JEMALLOC_VERSION_GID "87499f6748ebe4817571e817e9f680ccb5bf54a9")

set(TARGET_ARCHITECTURE "generic")
set(_vendor_id)
set(_cpu_family)
set(_cpu_model)
if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
  file(READ "/proc/cpuinfo" _cpuinfo)
  string(REGEX REPLACE ".*vendor_id[ \t]*:[ \t]+([a-zA-Z0-9_-]+).*" "\\1" _vendor_id "${_cpuinfo}")
  string(REGEX REPLACE ".*cpu family[ \t]*:[ \t]+([a-zA-Z0-9_-]+).*" "\\1" _cpu_family "${_cpuinfo}")
  string(REGEX REPLACE ".*model[ \t]*:[ \t]+([a-zA-Z0-9_-]+).*" "\\1" _cpu_model "${_cpuinfo}")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  exec_program("/usr/sbin/sysctl -n machdep.cpu.vendor" OUTPUT_VARIABLE _vendor_id)
  exec_program("/usr/sbin/sysctl -n machdep.cpu.model"  OUTPUT_VARIABLE _cpu_model)
  exec_program("/usr/sbin/sysctl -n machdep.cpu.family" OUTPUT_VARIABLE _cpu_family)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  get_filename_component(_vendor_id "[HKEY_LOCAL_MACHINE\\Hardware\\Description\\System\\CentralProcessor\\0;VendorIdentifier]" NAME CACHE)
  get_filename_component(_cpu_id "[HKEY_LOCAL_MACHINE\\Hardware\\Description\\System\\CentralProcessor\\0;Identifier]" NAME CACHE)
  mark_as_advanced(_vendor_id _cpu_id)
  string(REGEX REPLACE ".* Family ([0-9]+) .*" "\\1" _cpu_family "${_cpu_id}")
  string(REGEX REPLACE ".* Model ([0-9]+) .*" "\\1" _cpu_model "${_cpu_id}")
endif()

if(_vendor_id STREQUAL "GenuineIntel" OR
   _vendor_id STREQUAL "AuthenticAMD")
 set(JEMALLOC_CPU_SPINWAIT "__asm__ volatile(\"pause\")")
endif()

check_symbol_exists(atomic_fetchadd_long "sys/types.h;machine/atomic.h;inttypes.h" JEMALLOC_ATOMIC9)
check_symbol_exists(OSAtomicAdd64 "libkern/OSAtomic.h;inttypes.h" JEMALLOC_OSATOMIC)
check_symbol_exists(OSSpinLockLock "libkern/OSAtomic.h;inttypes.h" JEMALLOC_OSSPIN)
check_function_exists(_malloc_thread_cleanup JEMALLOC_MALLOC_THREAD_CLEANUP)

check_function_exists(_pthread_mutex_init_calloc_cb, JEMALLOC_MUTEX_INIT_CB)
check_function_exists(sbrk JEMALLOC_HAVE_SBRK)

set(CMAKE_REQUIRED_FLAGS "-Werror")
check_c_source_compiles("static __thread int
__attribute__((tls_model(\"initial-exec\"))) foo = 0; int main(void) { return 0; }" JEMALLOC_TLS_MODEL_SUPPORTED)
set(CMAKE_REQUIRED_FLAGS)

if (JEMALLOC_TLS_MODEL_SUPPORTED)
  set(JEMALLOC_TLS_MODEL "__attribute__((tls_model(\"initial-exec\")))")
endif()

check_type_size(void* JEMALLOC_SIZEOF_PTR)
if (JEMALLOC_SIZEOF_PTR EQUAL 8)
  set(JEMALLOC_LG_SIZEOF_PTR 3)
else()
  message(FATAL_ERROR "Unsupported pointer size")
endif()

set(JEMALLOC_USABLE_SIZE_CONST "const")
set(JEMALLOC_TCACHE ON)
set(JEMALLOC_MUNMAP ON)
set(JEMALLOC_IVSALLOC OFF)
if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(JEMALLOC_PURGE_MADVISE_DONTNEED ON)
  set(JEMALLOC_THREADED_INIT ON)
  set(JEMALLOC_USABLE_SIZE_CONST "")
  add_definitions(-D_GNU_SOURCE)
elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  set(JEMALLOC_LAZY_LOCK ON)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(JEMALLOC_PURGE_MADVISE_FREE ON)
  set(JEMALLOC_ZONE ON)

  set(CMAKE_EXTRA_INCLUDE_FILES "malloc/malloc.h")
  check_type_size(malloc_zone_t JEMALLOC_MZONE_SIZE)
  check_type_size(malloc_introspection_t JEMALLOC_MINT_SIZE)
  set(CMAKE_EXTRA_INCLUDE_FILES)

  if (JEMALLOC_MZONE_SIZE EQUAL 112)
    set(JEMALLOC_ZONE_VERSION "3")
  elseif(JEMALLOC_MZONE_SIZE EQUAL 120)
    set(JEMALLOC_ZONE_VERSION "5")
  elseif(JEMALLOC_MZONE_SIZE EQUAL 128)
    if (JEMALLOC_MINT_SIZE EQUAL 72)
      set(JEMALLOC_ZONE_VERSION "6")
    elseif (JEMALLOC_MINT_SIZE EQUAL 112)
      set(JEMALLOC_ZONE_VERSION "7")
    else()
      message(FATAL_ERROR "Unsupported malloc zone version")
    endif()
  elseif(JEMALLOC_MZONE_SIZE EQUAL 136)
    set(JEMALLOC_ZONE_VERSION "8")
  elseif(JEMALLOC_MZONE_SIZE GREATER 136)
    set(JEMALLOC_ZONE_VERSION "8")
  else()
    message(FATAL_ERROR "Unsupported malloc zone version")
  endif()
  set(JEMALLOC_IVSALLOC ON)
endif()

add_definitions(-D_REENTRANT)
add_compile_options(-O3 -funroll-loops)

# TLS on Darwin is "fake". We cannot use it with jemalloc, because
# emulated tls wants to use calloc() and friends
if (APPLE)
else()
  set(CMAKE_REQUIRED_FLAGS "-Werror")
  check_c_source_compiles("__thread int x;
  int main(void) { x = 42; return 0; }" JEMALLOC_TLS)
  set(CMAKE_REQUIRED_FLAGS)
endif()
check_function_exists(memalign JEMALLOC_OVERRIDE_MEMALIGN)
check_function_exists(valloc JEMALLOC_OVERRIDE_VALLOC)

check_type_size(int JEMALLOC_SIZEOF_INT)
if (JEMALLOC_SIZEOF_INT EQUAL 8)
  set(JEMALLOC_LG_SIZEOF_INT 3)
elseif (JEMALLOC_SIZEOF_INT EQUAL 4)
  set(JEMALLOC_LG_SIZEOF_INT 2)
else()
  message(FATAL_ERROR "Unsupported integer size")
endif()

check_type_size(long JEMALLOC_SIZEOF_LONG)
if (JEMALLOC_SIZEOF_LONG EQUAL 8)
  set(JEMALLOC_LG_SIZEOF_LONG 3)
elseif (JEMALLOC_SIZEOF_LONG EQUAL 4)
  set(JEMALLOC_LG_SIZEOF_LONG 2)
else()
  message(FATAL_ERROR "Unsupported long size")
endif()

check_type_size(intmax_t JEMALLOC_SIZEOF_INTMAX_T)
if (JEMALLOC_SIZEOF_INTMAX_T EQUAL 16)
  set(JEMALLOC_LG_SIZEOF_INTMAX_T 4)
elseif (JEMALLOC_SIZEOF_INTMAX_T EQUAL 8)
  set(JEMALLOC_LG_SIZEOF_INTMAX_T 3)
elseif (JEMALLOC_SIZEOF_INTMAX_T EQUAL 4)
  set(JEMALLOC_LG_SIZEOF_INTMAX_T 2)
else()
  message(FATAL_ERROR "Unsupported intmax_t size")
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/CheckPageSize.c.in"
               "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/CheckPageSize.c"
                IMMEDIATE @ONLY)
try_run(JEMALLOC_CHECK_PAGE_SIZE JEMALLOC_HAVE_PAGE_SIZE
        ${CMAKE_BINARY_DIR}
        "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/CheckPageSize.c"
        RUN_OUTPUT_VARIABLE JEMALLOC_STATIC_PAGE_SHIFT)

configure_file(${EXT_DIR}/include/jemalloc/jemalloc.h.in
               ${SPADES_BUILT_INCLUDE_DIR}/jemalloc/jemalloc.h)

configure_file(${EXT_DIR}/include/jemalloc/jemalloc_defs.h.in
               ${SPADES_BUILT_INCLUDE_DIR}/jemalloc/jemalloc_defs.h)


set(JEMALLOC_SRC arena.c
                 base.c
                 chunk.c
                 chunk_mmap.c
                 ctl.c
                 hash.c
                 jemalloc.c
                 mutex.c
                 quarantine.c
                 stats.c
                 tsd.c
                 atomic.c
                 bitmap.c
                 chunk_dss.c
                 ckh.c
                 extent.c
                 huge.c
                 mb.c
                 prof.c
                 rtree.c
                 tcache.c
                 util.c)


if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(JEMALLOC_SRC ${JEMALLOC_SRC} zone.c)
endif()

add_library(jemalloc STATIC
            ${JEMALLOC_SRC})

=== assembler/ext/src/llvm/CMakeLists.txt ===
project(llvm-support)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include)

include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckSymbolExists)

check_include_files(execinfo.h  HAVE_EXECINFO_H)
check_include_files(signal.h    HAVE_SIGNAL_H)
check_include_files(sys/stat.h  HAVE_SYS_STAT_H)
check_include_files(cxxabi.h    HAVE_CXXABI_H)
check_include_files(dlfcn.h     HAVE_DLFCN_H)
check_include_files(mach/mach.h HAVE_MACH_MACH_H)
check_include_files(link.h      HAVE_LINK_H)

check_symbol_exists(backtrace "execinfo.h" HAVE_BACKTRACE)

find_library(DL_LIB NAMES "dl")

add_definitions(-D__STDC_CONSTANT_MACROS)
add_definitions(-D__STDC_LIMIT_MACROS)

# FIXME: Signal handler return type, currently hardcoded to 'void'
set(RETSIGTYPE void)

configure_file(${EXT_DIR}/include/llvm/Config.h.in
               ${SPADES_BUILT_INCLUDE_DIR}/llvm/Config.h)

file(GLOB sources "[a-zA-Z]*.cpp" "[a-zA-Z]*.c")

add_library(llvm-support STATIC
  ${sources})
if (DL_LIB)
  target_link_libraries(llvm-support ${DL_LIB})
endif()

=== assembler/src/common/io/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(input CXX)

add_library(input STATIC
            reads/parser.cpp
            sam/read.cpp
            sam/sam_reader.cpp)

target_link_libraries(input BamTools samtools)

add_subdirectory(graph)

=== assembler/src/common/modules/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(modules CXX)

add_library(modules STATIC
            genome_consistance_checker.cpp
            alignment/gap_info.cpp
            alignment/bwa_index.cpp)

target_link_libraries(modules bwa)

=== debian/control ===
Source: spades
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Sascha Steinbiss <satta@debian.org>,
           Michael R. Crusoe <michael.crusoe@gmail.com>,
           Alexandre Mestiashvili <mestia@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-python,
               cmake,
               python3-dev,
               zlib1g-dev,
               libbz2-dev,
               libboost-dev,
               libbam-dev,
               libbamtools-dev,
               libhat-trie-dev,
               libhts-dev,
               libnlopt-dev,
               libnlopt-cxx-dev,
               libssw-dev,
               python3-yaml,
               python3-joblib,
               asciidoctor (>= 1.5.3),
               bwa,
               libbwa-dev,
               lynx
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/med-team/spades
Vcs-Git: https://salsa.debian.org/med-team/spades.git
Homepage: http://cab.spbu.ru/software/spades/

Package: spades
Architecture: any
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         python3,
         python3-distutils,
         python3-joblib,
         python3-yaml,
         bwa,
         bamtools,
         samtools,
         libnlopt0,
         libhat-trie0,
         libssw0
Description: genome assembler for single-cell and isolates data sets
 The SPAdes – St. Petersburg genome assembler is intended for both
 standard isolates and single-cell MDA bacteria assemblies.  It works
 with Illumina or IonTorrent reads and is capable of providing hybrid
 assemblies using PacBio and Sanger reads. You can also provide
 additional contigs that will be used as long reads.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
TMPDIR     := $(CURDIR)/install_spades
LIBDIR     := debian/$(DEB_SOURCE)/usr/lib/spades
mandir     := $(CURDIR)/debian/man
debfolder  := $(CURDIR)/debian

PREFIX:=/usr
BUILD_DIR:=$(CURDIR)/build_spades

DEB_CMAKE_EXTRA_FLAGS = -DSPADES_BOOST_ROOT=/usr/include
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export LC_ALL = C

%:
	dh $@  --with python3 --sourcedirectory=assembler/src --buildsystem=cmake

override_dh_clean:
	dh_clean -X.orig

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build_spades
	rm -rf install_spades
	rm -rf spades_test
	find . -name "*.pyc" -delete
	rm -rf $(debfolder)/man_src/*.html $(debfolder)/man_src/*.?
	rm -rf $(mandir)

override_dh_auto_configure:
	echo "Simply use spades_compile.sh in auto_build"

override_dh_auto_build:
	cd assembler && PREFIX=$(TMPDIR) ./spades_compile.sh
# Use Debian-packaged yaml module
	find $(TMPDIR) \
	-type f \
	-print0 \
	-exec sed -i 's/pyyaml[2|3]/yaml/' {} +

override_dh_installman:
	mkdir -p $(mandir)
	asciidoctor -a docdate='' -b manpage $(debfolder)/man_src/*.adoc
	cp $(debfolder)/man_src/*.? $(mandir)
	dh_installman --

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Ugly hack to make files available for dh_aut_test and autopkgtest
	mkdir -p $(CURDIR)/../share/
	ln -s $(CURDIR)/install_spades/share/spades $(CURDIR)/../share/
	ln -s  /usr/bin/bwa $(CURDIR)/install_spades/bin/spades-bwa
	$(TMPDIR)/bin/spades.py --test
	$(TMPDIR)/bin/metaspades.py --test
	$(TMPDIR)/bin/rnaspades.py --test
	# Difficult to test truSPAdes before installing because bwa-spades
	# is still not in the right place. Let's do this later in an
	# autopkgtest.
	# $(TMPDIR)/bin/truspades.py --test
	# Cleunup symlinks
	rm -rf $(CURDIR)/../share/
	unlink $(CURDIR)/install_spades/bin/spades-bwa
endif

override_dh_auto_install:
	echo "Nothing to install"
	find $(CURDIR) -name *.pyc -delete

override_dh_install:
	dh_install
	mkdir -p $(LIBDIR)
	mv debian/$(DEB_SOURCE)/usr/bin $(LIBDIR)
	mkdir -p debian/$(DEB_SOURCE)/usr/bin
	install debian/bin/spades debian/$(DEB_SOURCE)/usr/bin/
	chmod +x debian/$(DEB_SOURCE)/usr/bin/spades
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/GPLv2.txt
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/README.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/LICENSE
	ln -s ../../../share/spades/VERSION debian/$(DEB_SOURCE)/usr/lib/spades/bin/VERSION


override_dh_installdocs:
	dh_installdocs
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/*.html
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/manual.md

override_dh_installchangelogs:
	LANG="C" LANGUAGE="en_US:en" LC_ALL=C.UTF-8 lynx -dump assembler/changelog.html > changelog
	dh_installchangelogs changelog
	rm changelog

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz" \
  https://github.com/ablab/spades/releases .*/archive/v*@ANY_VERSION@@ARCHIVE_EXT@

## spades 3.15.4+dfsg

=== debian/changelog ===
spades (3.15.4+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Lance Lin ]
  * d/patches/0003_accept-system-bwa.patch - refactored 'which'
    Closes: #1010788

  [ Andreas Tille ]
  * Review copyright

 -- Lance Lin <LQi254@protonmail.com>  Tue, 10 May 2022 20:15:40 +0700

spades (3.15.4+dfsg-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * New upstream version
  * Refreshed patches
  * debian/upstream/metadata: Added many missing papers
  * remove assembler/ext/src/llvm/ConvertUTF.cpp
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)

  [ Steffen Moeller ]
  * d/u/metadata
    - yamllint cleanliness
    - added ref to bioconda
  * Add salsa-ci file (routine-update)
  * Refer to common license file for Apache-2.0.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Upstream addressed / -> // in generate_quality (less nice, though)
  * Prepared PRs for spelling errors found by Michael

  [ Andreas Tille ]
  * Adjust patches
  * Remove redundant gbp.conf

  [ Juhani Numminen ]
  * Enable parallel builds by ignoring spades_compile.sh
    - Fix patches for the bypassing of spades_compile.sh
  * Remove gcc7.patch: applied upstream
  * python3.patch: add coronaspades.py and before_start_stage.py
  * Simplify debian/rules: do not attempt to run as-installed tests before
    installation
  * Install scripts under FHS-compliant path /usr/libexec/spades/
    - Adjust 0118_adjust_spades_home_again.patch
  * Add patches to make the test suite runnable
  * d/links: Add new binary coronaspades(.py)
  * Remove unused adapt_to_debian_pathes.patch
  * Add d/clean for test artifacts
  * Add disable_local_convertutf.patch: to cover for dfsg-removed ConvertUTF.o,
    link against system's LLVMSupport.a
  * Build-Deps: does not build python extensions; s/python3-dev/python3-all/
  * Depends: remove explicit shared libs (handled as ${shlibs:Depends})
  * Use vendored boost which has local modifications to avoid include problems
    during program use.

  [ Étienne Mollier ]
  * Add fix-sigill-on-non-popcnt-cpus.patch; fixes baseline violation.

  [ Andreas Tille ]
  * d/watch:
     - Fix to detect new versions on github (routine-update)
     - Use proper filename for download
  * Standards-Version: 4.6.0 (routine-update)
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on asciidoctor.

  [ Étienne Mollier ]
  * Adjust fix-sigill-on-non-popcnt-cpus.patch to not overflow on large int.
  * d/control: add myself to Uploaders.

 -- Étienne Mollier <emollier@debian.org>  Mon, 11 Apr 2022 21:30:33 +0200

=== debian/control ===
Source: spades
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Sascha Steinbiss <satta@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>,
           Alexandre Mestiashvili <mestia@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cmake,
               python3-all,
               zlib1g-dev,
               libbz2-dev,
               libbam-dev,
               libbamtools-dev,
               libhts-dev,
               libnlopt-dev,
               libnlopt-cxx-dev,
               libssw-dev,
               llvm-dev,
               python3-yaml,
               python3-joblib,
               asciidoctor,
               bwa,
               libbwa-dev,
               lynx
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/spades
Vcs-Git: https://salsa.debian.org/med-team/spades.git
Homepage: http://cab.spbu.ru/software/spades/
Rules-Requires-Root: no

Package: spades
Architecture: any
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         python3,
         python3-distutils,
         python3-joblib,
         python3-yaml,
         bwa,
         bamtools,
         samtools
Description: genome assembler for single-cell and isolates data sets
 The SPAdes – St. Petersburg genome assembler is intended for both
 standard isolates and single-cell MDA bacteria assemblies.  It works
 with Illumina or IonTorrent reads and is capable of providing hybrid
 assemblies using PacBio and Sanger reads. You can also provide
 additional contigs that will be used as long reads.
 .
 This package provides the following additional pipelines:
  * metaSPAdes – a pipeline for metagenomic data sets
  * plasmidSPAdes – a pipeline for extracting and assembling plasmids
    from WGS data sets
  * metaplasmidSPAdes – a pipeline for extracting and assembling
    plasmids from metagenomic data sets
  * rnaSPAdes – a de novo transcriptome assembler from RNA-Seq data
  * truSPAdes – a module for TruSeq barcode assembly
  * biosyntheticSPAdes – a module for biosynthetic gene cluster
    assembly with paired-end reads
 .
 SPAdes provides several stand-alone binaries with relatively simple
 command-line interface: k-mer counting (spades-kmercounter), assembly
 graph construction (spades-gbuilder) and long read to graph aligner
 (spades-gmapper).

## spades 3.15.5%2Bdfsg

=== assembler/ext/src/easel/CMakeLists.txt ===
project(easel C)

set(EASEL_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(EASEL_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(EASEL_TOOLS_BINARY_DIR ${EASEL_BINARY_DIR}/bin)
set(EASEL_BUILT_INCLUDE_DIR ${EASEL_BINARY_DIR}/include)

set(EASEL_DATE "July 2016")
set(EASEL_COPYRIGHT "Copyright (C) 2016 Howard Hughes Medical Institute")
set(EASEL_LICENSE "Freely distributed under the BSD open source license.")
set(EASEL_VERSION 0.43)
set(EASEL_URL "http://bioeasel.org/")

include(CheckIncludeFiles)

check_include_files(endian.h HAVE_FEATURES_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(sys/param.h HAVE_SYS_PARAM_H)
check_include_files(sys/sysctl.h HAVE_SYS_SYSCTL_H)

check_include_files(emmintrin.h HAVE_SSE2)
check_include_files(pmmintrin.h HAVE_SSE3)
check_include_files(xmmintrin.h HAVE_SSE)
if (HAVE_SSE2)
  set(HAVE_SSE2_CAST 1)
endif()

include(CheckFunctionExists)
check_function_exists(chmod HAVE_CHMOD)
check_function_exists(fseeko HAVE_FSEEKO)
check_function_exists(fstat HAVE_FSTAT)
check_function_exists(getcwd HAVE_GETCWD)
check_function_exists(getpid HAVE_GETPID)
check_function_exists(mkstemp HAVE_MKSTEMP)
check_function_exists(popen HAVE_POPEN)
check_function_exists(putenv HAVE_PUTENV)
check_function_exists(stat HAVE_STAT)
check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(sysconf HAVE_SYSCONF)
check_function_exists(sysctl HAVE_SYSCTL)
check_function_exists(times HAVE_TIMES)
check_function_exists(erfc HAVE_ERFC)

find_package(Threads)
if (CMAKE_USE_PTHREADS_INIT)
  set(HAVE_PTHREAD 1)
endif()

set(eslLIBRARY 1)
set(HAVE_FUNC_ATTRIBUTE_NORETURN 1)

configure_file("${EASEL_MAIN_SRC_DIR}/esl_config.h.cmake"
               "${EASEL_BUILT_INCLUDE_DIR}/esl_config.h")

set(easel_src
  easel.c
  esl_alphabet.c esl_avx.c esl_buffer.c esl_cluster.c esl_composition.c esl_dirichlet.c
  esl_distance.c esl_dmatrix.c esl_dsqdata.c esl_exponential.c esl_fileparser.c esl_gamma.c
  esl_gencode.c esl_getopts.c esl_gev.c esl_gumbel.c esl_heap.c esl_histogram.c
  esl_hmm.c esl_hyperexp.c esl_keyhash.c esl_mem.c esl_minimizer.c esl_mixgev.c
  esl_mpi.c esl_msa.c esl_msacluster.c esl_msafile.c esl_msafile2.c esl_msafile_a2m.c
  esl_msafile_afa.c esl_msafile_clustal.c esl_msafile_phylip.c esl_msafile_psiblast.c
  esl_msafile_selex.c esl_msafile_stockholm.c esl_msashuffle.c esl_msaweight.c
  esl_normal.c esl_paml.c esl_random.c esl_randomseq.c
  esl_ratematrix.c esl_recorder.c esl_regexp.c esl_rootfinder.c
  esl_scorematrix.c esl_sq.c esl_sqio.c esl_sqio_ascii.c
  esl_sqio_ncbi.c esl_sse.c esl_ssi.c esl_stack.c esl_stats.c esl_stopwatch.c
  esl_stretchexp.c esl_threads.c esl_tree.c esl_vectorops.c esl_vmx.c esl_weibull.c esl_workqueue.c
  esl_wuss.c)

add_library(easel STATIC ${easel_src})
target_link_libraries(easel m)
target_include_directories(easel SYSTEM PUBLIC ${EASEL_BUILT_INCLUDE_DIR} ${EASEL_MAIN_SRC_DIR})

=== debian/control ===
--- 
+++ 
@@ -9,12 +9,16 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-python,
+               clang-format,
+               clang-tidy,
+               clang-tools,
                cmake,
                python3-all,
                zlib1g-dev,
                libbz2-dev,
                libbam-dev,
                libbamtools-dev,
+               libc++-dev,
                libhts-dev,
                libnlopt-dev,
                libnlopt-cxx-dev,
@@ -26,7 +30,7 @@
                bwa,
                libbwa-dev,
                lynx
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/spades
 Vcs-Git: https://salsa.debian.org/med-team/spades.git
 Homepage: http://cab.spbu.ru/software/spades/
